<template>
  <div class="home">
    <div class="overlay-all" v-if="busy">
      <md-progress-spinner class="md-accent" :md-diameter="90" md-mode="indeterminate"></md-progress-spinner>
    </div>
    <md-toolbar class="toolbar">
      <h3 class="md-title">
        <img alt="Vue logo" style="height:30px" src="@/assets/logo.png">
        MG Tasker
      </h3>
      <div style="display:flex; ">
        <div id="user-name-label" style="display:flex; align-items: center;">
          <md-icon>person</md-icon>
          {{userFullName}}
        </div>
        <md-button id="logout-btn" class="md-icon-button md-raised" @click="logout()">
          <md-icon>exit_to_app</md-icon>
        </md-button>
      </div>
    </md-toolbar>
    <div></div>

    <TableComponent :list="taskList" @interface="handleFcAfterDateBack"/>
    <div>
      <md-button id="add-task-btn" class="md-secondary md-raised" @click="addTask()">
        <md-icon>add</md-icon>Add New Task
      </md-button>
    </div>
    <md-dialog :md-active.sync="showDialog">
      <md-dialog-title v-if="taskPayload._id===undefined">Add Task</md-dialog-title>
      <md-dialog-title v-if="taskPayload._id!==undefined">Edit Task</md-dialog-title>
      <md-checkbox v-model="taskPayload.completed">Completed</md-checkbox>
      <md-field>
        <label>Name</label>
        <md-input id="task-name" v-model="taskPayload.name" placeholder="Insert name"></md-input>
      </md-field>
      <md-field>
        <label>Description</label>
        <md-textarea
          id="task-description"
          v-model="taskPayload.description"
          placeholder="Insert description"
        ></md-textarea>
      </md-field>

      <md-dialog-actions>
        <md-button class="md-primary" @click="cancelTask()">Cancel</md-button>
        <md-button id="save-task-btn" class="md-primary" @click="saveTask()">Save</md-button>
      </md-dialog-actions>
    </md-dialog>
  </div>
</template>

<script>
import TableComponent from "@/components/TableComponent.vue";
// import AddEditComponent from "@/components/AddEditComponent.vue";
import ApiService from "@/services/ApiService.js";

export default {
  name: "home",
  components: {
    TableComponent
    // AddEditComponent
  },

  data() {
    return {
      userFullName: String,
      busy: true,
      isLogin: false,
      showDialog: false,
      taskList: [],
      taskPayload: {
        name: "",
        description: "",
        completed: false,
        dueDate: new Date()
      }
    };
  },
  async created() {
    try {
      this.userFullName = localStorage.getItem("full_name");
      this.busy = true;
      this.taskList = await ApiService.getTasks();
      this.busy = false;
    } catch (error) {
      this.error = error.message;
    }
  },
  methods: {
    addTask() {
      this.taskPayload = {};
      this.showDialog = true;
    },

    cancelTask() {
      this.taskPayload = {};
      this.showDialog = false;
    },
    async saveTask() {
      this.busy = true;
      this.showDialog = false;
      if (this.taskPayload._id !== undefined) {
        await ApiService.updateTask(this.taskPayload);
      } else {
        await ApiService.createTask(this.taskPayload);
      }
      this.taskList = await ApiService.getTasks();
      this.busy = false;
    },
    async deleteTask(obj) {
      this.busy = true;
      await ApiService.deleteTask(obj._id);
      this.taskList = await ApiService.getTasks();
      this.busy = false;
    },
    async completeTask(obj) {
      this.busy = true;
      await ApiService.updateTask(obj);
      this.taskList = await ApiService.getTasks();
      this.busy = false;
    },
    handleFcAfterDateBack(e) {
      const event = e;


      switch (event.type) {
        case "REMOVE":
          this.deleteTask(event);
          break;
        case "CHECK":
          event.completed = !event.completed;
          this.completeTask(event);
          break;
        case "EDIT":
          this.taskPayload = event;
          this.showDialog = true;
          break;
        default:
          console.log(event.type, "not specified");
          break;
      }
    },
    logout() {
      ApiService.logout();
    }
  }
};
</script>

<style>
.overlay-all {
  display: flex;
  position: absolute;
  top: 0;
  left: 0;
  z-index: 6;
  background-color: grey;
  width: 100%;
  height: 100%;
  opacity: 0.6;
  justify-content: center;
  align-items: center;
}
.home {
  display: flex;
  flex-direction: column;
  justify-content: center;
}
.md-dialog {
  max-width: 768px;
  padding: 10px;
}
.toolbar {
  display: flex;
  justify-content: space-between;
}
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}
</style>
